//
// SVG 쓮eXg
//
#include <windows.h>
#include <atlbase.h>
CComModule _Module;
#include <atlwin.h>
#include <atlwin.h>
#include <atlcom.h>
#include <atlhost.h>

static HRESULT invoke(IDispatch *idispatch, int type, const char *name, VARIANTARG args[]=NULL, int nargs=0, VARIANT *result = NULL, DISPID params[] = NULL, int nparams = 0)
{
	USES_CONVERSION;
	
	OLECHAR* method = A2OLE(name);
	DISPID id;
	HRESULT hr;
	if (SUCCEEDED(hr = idispatch->GetIDsOfNames(IID_NULL, &method, 1, GetUserDefaultLCID(), &id))) {
		DISPPARAMS param =  {args, params, nargs, nparams};
		if (result) {
			VariantInit(result);
		}
		hr = idispatch->Invoke(id, IID_NULL, GetUserDefaultLCID(), type, &param, result, NULL, NULL);
	}
	return hr;
}

static HRESULT method(IDispatch *idispatch, const char *method, VARIANTARG args[], int narg, VARIANT *result)
{
	return invoke(idispatch, DISPATCH_METHOD, method, args, narg, result);
}

static HRESULT getProperty(IDispatch *idispatch, const char *name, VARIANT *result)
{
	return invoke(idispatch, DISPATCH_PROPERTYGET, name, NULL, 0, result);
}

static HRESULT putProperty(IDispatch *idispatch, const char *name, VARIANT *var)
{
	DISPID putProp = DISPID_PROPERTYPUT;
	return invoke(idispatch,
				  (var->vt == VT_UNKNOWN || var->vt == VT_DISPATCH || (var->vt & VT_ARRAY) || (var->vt & VT_BYREF)) ? DISPATCH_PROPERTYPUTREF : DISPATCH_PROPERTYPUT,
				  name, var, 1, NULL, &putProp, 1);
}

#import "c:\WINDOWS\system32\Adobe\SVG Viewer 3.0\NPSVG3.dll" rename_namespace("SVG") named_guids

class CSVGWindow : public CWindowImpl<CSVGWindow, CAxWindow>
{
public:
	CComPtr<SVG::ISVGControl> svg;

	HRESULT init() {
		HRESULT hr;
		if (SUCCEEDED(hr = CreateControl(OLESTR("Adobe.SVGCtl.3")))) {
			hr = QueryControl(&svg);
		}
		return hr;
	}

	LRESULT OnDestroy(UINT, WPARAM, LPARAM, BOOL&){
		if (svg) {
			svg.Release();
			svg.Detach();
		}
		// AvP[VI XXX
		PostQuitMessage(0);
		return S_OK;
	}

	~CSVGWindow() {
		if (svg) {
			svg.Release();
			svg.Detach();
		}
	}

	BEGIN_MSG_MAP(CSVGWindow)
        MESSAGE_HANDLER(WM_DESTROY,  OnDestroy)
	END_MSG_MAP()
};

class CMyWindow : public CWindowImpl<CMyWindow>
{
protected:
	BEGIN_MSG_MAP(CMyWindow)
		MESSAGE_HANDLER(WM_DESTROY,  OnDestroy)
		MESSAGE_HANDLER(WM_LBUTTONDOWN,  OnButtonDown)
	END_MSG_MAP()

	LRESULT OnDestroy(UINT, WPARAM, LPARAM, BOOL&){
		// AvP[VI XXX
		PostQuitMessage(0);
		return S_OK;
	}
		
	SVG::ISVGControl *svg;

	LRESULT OnButtonDown(UINT, WPARAM, LPARAM, BOOL&){
		if (svg) {

			CComPtr<IDispatch>doc;
			svg->raw_getSVGDocument(&doc);

			if (doc) {
				
				{
					USES_CONVERSION;
					VARIANT result;
					getProperty(doc, "URL", &result);
					if (result.vt == VT_BSTR) {
						TCHAR *str = OLE2T(result.bstrVal);
						MessageBox(str, TEXT("prop:URL"), MB_OK);
					}
				}
				
				VARIANT root;
				method(doc, "getRootElement", NULL, 0, &root);
				if (root.vt == VT_DISPATCH && root.pdispVal) {
					MessageBox(TEXT("success to get rootElement"), TEXT("INFO"), MB_OK);

					USES_CONVERSION;
					VARIANT elem;
					
					VARIANT arg;
					V_VT(&arg) = VT_BSTR;
					V_BSTR(&arg) = A2OLE("hoge");
					method(root.pdispVal, "getElementById", &arg, 1, &elem);
					if (elem.vt == VT_DISPATCH && elem.pdispVal) {
						MessageBox(TEXT("success to get element hoge"), TEXT("INFO"), MB_OK);

						USES_CONVERSION;
						
						// ͋tI
						VARIANT args[2];
						V_VT(&args[0]) = VT_BSTR;
						V_BSTR(&args[0]) = A2OLE("10");
						V_VT(&args[1]) = VT_BSTR;
						V_BSTR(&args[1]) = A2OLE("r");
						method(elem.pdispVal, "setAttribute", args, 2, NULL);
						
						VARIANT result;
						VARIANT arg;
						V_VT(&arg) = VT_BSTR;
						V_BSTR(&arg) = A2OLE("r");
						method(elem.pdispVal, "getAttribute", &arg, 1, &result);
						if (result.vt == VT_BSTR) {
							TCHAR *str = OLE2T(result.bstrVal);
							MessageBox(str, TEXT("getAttribute:r"), MB_OK);
						}
						VariantClear(&result);
					}
				}
			}
		}
		return S_OK;
	}

public:
	CMyWindow() {
		svg = NULL;
	}

	void setSvg(SVG::ISVGControl *svg) {
		this->svg = svg;
	}
};

int APIENTRY WinMain(HINSTANCE hInstance,
					 HINSTANCE hPrevInstance,
					 LPSTR     lpCmdLine,
					 int       nCmdShow)
{
	int ret;

	_Module.Init(NULL, hInstance);
	AtlAxWinInit();

	// x[X
	CMyWindow base;
	base.Create(base, CWindow::rcDefault, NULL, WS_OVERLAPPEDWINDOW|WS_VISIBLE);

	// SVG 
	CSVGWindow svgWin;
	RECT rect = {10, 10, 500, 500};
	svgWin.Create(base, rect, NULL, WS_CHILD|WS_VISIBLE);

	// SVG 
	if (SUCCEEDED(svgWin.init())) {
		svgWin.svg->PutSRC(OLESTR("http://ruriko.denpa.org/~go/test.svg"));
		base.setSvg(svgWin.svg);
	} else {
		MessageBox(base, TEXT("Failed to load SVG"), TEXT("Error"), MB_OK);
	}

	// C
	MSG msg;
	while (GetMessage(&msg, NULL, 0, 0)){
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	ret = msg.wParam;
	
	_Module.Term();
	return ret;
}
